// xdocdiff -TortoiseSVNWord, Excel, PowerPoint, pdfdiff悤ɂc[-
// 2005 (C) S.Kohno
//
// XDocDiff.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

/**
 * ϊΏۂ̃t@CAKvɉăe|fBNgɃRs[֐
 * @param srcbuf ϊΏۂ̃t@CpX
 * @return KvɉăRs[sƂ̃t@CpX
 */
std::string CopyToTempDirectoryIfNeeded(TCHAR* srcbuf)
{
	std::string src(srcbuf);

	TCHAR tempDir[512];
	GetTempPath(512, tempDir);

	std::string dest(tempDir);
	std::string xt = src.substr(src.length() - 9, 9);

	if (strcmp(xt.c_str(), ".svn-base") == 0) { 
		// t@C ".svn-base"ŏIĂ邽߁Aɕϊł悤Agqte|fBNgɃRs[
		std::string name = src.substr(src.find_last_of('\\') + 1, src.length() - (src.find_last_of('\\') + 1));
		dest += name;
		dest += src.substr(src.length() - 13, 4);

		CopyFile(srcbuf, dest.c_str(), FALSE);
		SetFileAttributes(dest.c_str(), FILE_ATTRIBUTE_NORMAL);				// ǂݎpĂ
		MoveFileEx(dest.c_str(), NULL, MOVEFILE_DELAY_UNTIL_REBOOT);		// ċNɍ폜悤ɂĂ

		return dest;
	}
	else {
		static int count = 1;
		std::string dir = src.substr(0, src.find_last_of('\\') + 1);

		if (strcmp(tempDir, dir.c_str()) == 0) {
			return src;
		}

		// e|fBNgȊOɂt@CȂ̂ŁAe|fBNgɃRs[
		std::string name = src.substr(src.find_last_of('\\') + 1, src.length() - (src.find_last_of('\\') + 1));
		dest += name;

		CopyFile(srcbuf, dest.c_str(), FALSE);
		SetFileAttributes(dest.c_str(), FILE_ATTRIBUTE_NORMAL);				// ǂݎpĂ
		MoveFileEx(dest.c_str(), NULL, MOVEFILE_DELAY_UNTIL_REBOOT);		// ċNɍ폜悤ɂĂ

		return dest;
	}
}

/**
 * TortoiseSVNCXg[ĂtH_AWXg擾֐
 * @return TortoiseSVNCXg[ĂtH_
 */
std::string GetTortoiseSVNDirectory()
{
	HKEY hkey;
	LONG retCode;
	
	retCode = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\TortoiseSVN", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_EXECUTE, NULL, &hkey, NULL);
		
	if (retCode != ERROR_SUCCESS) {
		MessageBox(NULL, "WXgL[擾G[\r\nHKEY_LOCAL_MACHINE\\SOFTWARE\\TortoiseSVN", "error", MB_OK);
		return "";
	}
	
	BYTE data[1024] = {0};
	DWORD size = 1024;
	RegQueryValueEx(hkey, "Directory", NULL, NULL, data, &size);
	RegCloseKey(hkey);
	
	std::string tortoiseSvnDirectory;
	tortoiseSvnDirectory = (char*)data;
	
	return tortoiseSvnDirectory;
}

/**
 * TortoiseSVNŐݒ肳Ădiffc[̃pXAWXg擾֐
 * @return TortoiseSVNŐݒ肳Ădiffc[̃pX
 */
std::string GetDiffToolPath()
{
	HKEY hkey;
	LONG retCode;
	
	// TortoiseSVÑtH_擾
	retCode = RegCreateKeyEx(HKEY_CURRENT_USER, "SOFTWARE\\TortoiseSVN", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_EXECUTE, NULL, &hkey, NULL);
		
	if (retCode != ERROR_SUCCESS) {
		MessageBox(NULL, "WXgL[擾G[\r\nHKEY_CURRENT_USER\\SOFTWARE\\TortoiseSVN", "error", MB_OK);
		return 0;
	}
	
	BYTE data[1024] = {0};
	DWORD size = 1024;
	RegQueryValueEx(hkey, "Diff", NULL, NULL, data, &size);
	RegCloseKey(hkey);
	
	std::string path;
	path = (char*)data;
	
	// TortoiseSVN̓diffc[I΂ĂƂ́ApX̐擪 '#' ɂȂĂB
	// ̏ꍇ̓pX𖳌ɂB
	if (path.length() > 0 && path[0] == '#')  path = "";

	return path;
}

/**
 * t@CeLXgt@Cɕϊ֐
 * @param convexepath ϊɎgpxdoc2txt̃pX
 * @param filepath1 ϊΏۂ̃t@CpX P
 * @param filepath2 ϊΏۂ̃t@CpX Q
 * @return ɏItrueAȊȌꍇfalse
 */
bool ConvertToText(std::string convexepath, std::string filepath1, std::string filepath2)
{
	std::string command;
	command	= " -f \"";
	command += filepath1;
	command += "\" \"";
	command += filepath2;
	command += "\"";

	STARTUPINFO startupinfo;
	PROCESS_INFORMATION proc_info;
	TCHAR command_t[2048];
	lstrcpy(command_t, command.c_str());

	ZeroMemory(&startupinfo, sizeof(startupinfo));
	startupinfo.cb = sizeof(startupinfo);
	startupinfo.dwFlags = STARTF_USESHOWWINDOW;
	startupinfo.wShowWindow = SW_HIDE;

	// txtɕϊ
	BOOL ret;
	ret = CreateProcess(convexepath.c_str(), command_t, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, 
		&startupinfo, &proc_info);

	if (!ret) {
		printf("G[\n");
		DWORD errorcode = GetLastError();

		TCHAR buff[512];
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, errorcode, GetSystemDefaultLangID(), buff, 512, NULL); 

		printf(buff);
		printf("\n");

		MessageBox(NULL, "xdoc2txt.exe NG[", "err", MB_OK);
		MessageBox(NULL, buff, "err", MB_OK);

		return false;
	}

	WaitForSingleObject(proc_info.hProcess, INFINITE);		// ϊ̊҂

	return true;
}

/**
 * 񒆂̕ʂ̕ƒu֐
 * @param base s
 * @param oldstr u镶
 * @param newstr u镶
 */
void ReplaceString(std::string& base, std::string oldstr, std::string newstr)
{
	int pos;
	
	while ((pos = base.find(oldstr)) != std::string::npos) {
		base.replace(pos, oldstr.length(), newstr);
	}
}

#ifdef _DEBUG
int _tmain(int argc, _TCHAR* argv[])
#else
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
#endif
{
 	if (__argc < 3)  return 0;

	std::string registryDiffToolPath = GetDiffToolPath();	
	
	if (registryDiffToolPath.length() == 0) {
		// TortoiseSVNdiffc[IĂ
		registryDiffToolPath = GetTortoiseSVNDirectory();
		
		if (registryDiffToolPath.length() == 0)  return 0;
		
		registryDiffToolPath = "\"" + registryDiffToolPath;
		registryDiffToolPath += "bin\\TortoiseMerge.exe\"  /base:%base /mine:%mine /basename:%bname /minename:%yname";
	}

#ifdef _DEBUG
	// fobOpɕϐo͂
	for (int i=0; i<__argc; i++) {
		printf("__argv[%d]: %s\n", i, __argv[i]);
	}
	
	printf("registryDiffToolPath: %s\n", registryDiffToolPath.c_str());

	int n;
	scanf("%d", &n);	// R\[悤A͂҂
#endif

	std::string exepath(__argv[0]);
	std::string convexepath;

	convexepath = exepath.substr(0, exepath.find_last_of("\\"));
	convexepath += "\\xdoc2txt.exe";

	std::string srcfile1 = CopyToTempDirectoryIfNeeded(__argv[1]);
	std::string srcfile2 = CopyToTempDirectoryIfNeeded(__argv[2]);

	// txtɕϊ
	BOOL ret;
	ret = ConvertToText(convexepath, srcfile1, srcfile2);
	if (!ret)  return 0;

	if (srcfile1 != __argv[1])  DeleteFile(srcfile1.c_str());
	if (srcfile2 != __argv[2])  DeleteFile(srcfile2.c_str());

	std::string dstfile1;		///< ϊ̃t@CpX1
	dstfile1 = "\"";
	dstfile1 += srcfile1.substr(0, srcfile1.find_last_of("."));
	dstfile1 += ".txt\"";

	std::string dstfile2;		///< ϊ̃t@CpX2
	dstfile2 = "\"";
	dstfile2 += srcfile2.substr(0, srcfile2.find_last_of("."));
	dstfile2 += ".txt\"";

	std::string commandString = registryDiffToolPath;
	
	if (commandString.find("%base") == std::string::npos && commandString.find("%mine") == std::string::npos) {
		// %base A%minew肳ĂȂBPɃt@CɂB
		commandString += " ";
		commandString += dstfile1;
		commandString += " ";
		commandString += dstfile2;
	}
	else {
		std::string filename1 = dstfile1.substr( dstfile1.find_last_of('\\') + 1, dstfile1.length() - dstfile1.find_last_of('\\') - 2);
		std::string filename2 = dstfile2.substr( dstfile2.find_last_of('\\') + 1, dstfile2.length() - dstfile2.find_last_of('\\') - 2);

		ReplaceString(commandString, "%base", dstfile1);
		ReplaceString(commandString, "%mine", dstfile2);
		ReplaceString(commandString, "%bname", filename1);
		ReplaceString(commandString, "%yname", filename2);
	}

#ifdef _DEBUG
	// fobOpɕϐo͂
	printf("commandString: %s\n", commandString.c_str());

	scanf("%d", &n);	// R\[悤A͂҂
#endif

	// diffc[N
	STARTUPINFO startupinfo;
	PROCESS_INFORMATION proc_info;
	ZeroMemory(&startupinfo, sizeof(startupinfo));
	startupinfo.cb = sizeof(startupinfo);

	TCHAR command_t[2048];
	lstrcpy(command_t, commandString.c_str());

	ret = CreateProcess(NULL, command_t, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, 
		&startupinfo, &proc_info);

	if (!ret) {
		printf("G[\n");
		DWORD errorcode = GetLastError();

		TCHAR buff[512];
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, errorcode, GetSystemDefaultLangID(), buff, 512, NULL); 

		printf(buff);
		printf("\n");

		MessageBox(NULL, "diffc[ NG[", "err", MB_OK);
		MessageBox(NULL, buff, "err", MB_OK);

		return 0;
	}

	MoveFileEx(dstfile1.c_str(), NULL, MOVEFILE_DELAY_UNTIL_REBOOT);		// ċNɍ폜悤ɂĂ
	MoveFileEx(dstfile2.c_str(), NULL, MOVEFILE_DELAY_UNTIL_REBOOT);		// ċNɍ폜悤ɂĂ

	return 0;
}

